﻿-- Author      : Nogarder
-- Create Date : 2010/7/1 16:34:28

local NPA_NameText={}
--config
local NPA_NameText_DefaultSetting={
		["NameText_Name"]=1,
		["NameText_Guild"]=0,
		["NameText_NPCGuild"]=0,
		["NameText_BoldHostile"]=1,
		["NameText_BoldNonHostile"]=1,
		["NameText_BoldNeutral"]=1,

		["NameText_HideGuildInInstance"]=1,

		["NameText_HideWithHealthBar"]=1,

		["NameText_Mark"]=0,
		["NameText_MarkTarget"]=1,
		["NameText_MarkFocus"]=1,
		["NameText_MarkMouseover"]=1,

		["NameText_MarkGuildMember"]=1,
		["NameText_MarkFriend"]=1,
		["NameText_MarkRaidMember"]=1,
		["NameText_MarkPartyMember"]=1,
		["NameText_MarkHideInInstance"]=1,

		["NameText_ColorTarget"]=0,
		["NameText_ColorMouseover"]=0,
		["NameText_ColorFocus"]=0,
		
		["NameText_MarkColorByType"]=1,
		["NameText_HideTotemName"]=1,

		["NameText_MarkPartyAsRaid"]=0,
		["NameText_Tapped"]=0,
		["NameText_FullName"]=0,

		["NameText_ShowPortrait"]=0,
		["NameText_ShowHostilePortrait"]=1,
		["NameText_ShowNonHostilePortrait"]=1,
		["NameText_ShowPartyPortrait"]=1,
		["NameText_ShowRaidPortrait"]=1,
		["NameText_ShowGuildPortrait"]=1,
		["NameText_ShowOnlyPlayerPortrait"]=0,
		["NameText_ShowTargetPortrait"]=1,
		["NameText_ShowFocusPortrait"]=1,
		["NameText_ShowMouseoverPortrait"]=1,

		["NameText_AutoHideGuild"]=0,

		["NameText_SeparateNameText"]=0,

		["NameText_ShowBorder"]=0,
		["NameText_ShowBackground"]=0,
		["NameText_ShowPVPFlag"]=0,
		
		["NameText_QuestUnitName"]=1,
		["NameText_TargetName"]=1,
		["NameText_FocusName"]=1,
		["NameText_MouseoverName"]=1,

		["NameText_LimitLength"]=0,
		["NameText_Length"]=18,

		["NameText_HostilePlayerName"]=1,
		["NameText_NeutralPlayerName"]=1,
		["NameText_FriendlyPlayerName"]=1,
		["NameText_HostileNonPlayerName"]=1,
		["NameText_NeutralNonPlayerName"]=1,
		["NameText_FriendlyNonPlayerName"]=1,

		--0=by health
		--1=by faction
		--2=by class
		--3=dont change
		["NameText_ColorHostilePlayerData"]=2,
		["NameText_ColorNeutralPlayerData"]=2,
		["NameText_ColorFriendlyPlayerData"]=2,
		["NameText_ColorHostileNonPlayerData"]=1,
		["NameText_ColorFriendlyNonPlayerData"]=1,
		["NameText_ColorNeutralNonPlayerData"]=1,
		["NameText_ColorTappedData"]=3,
		["NameText_ColorPvPFriendlyData"]=2,
		["NameText_ColorPvPHostileData"]=2,
		["NameText_ColorPvPNeutralData"]=2,

		["NameText_CustomTextData"]={
			["HostilePlayer"]=0,
			["FriendlyPlayer"]=0,
			["FriendlyNonPlayer"]=0,
			["HostileNonPlayer"]=0,
			["NeutralPlayer"]=0,
			["NeutralNonPlayer"]=0,
			["TappedMob"]=0,
			["PvPHostile"]=0,
			["PvPFriendly"]=0,
			["PvPNeutral"]=0,
			DeepCheck=1,
		},

		["NameText_PVPFlagData"]={
			OffsetX=0,
			OffsetY=20,
			Height=15,
			Width=18,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="Interface\\Addons\\NPA\\texture\\combaticon",
			TextureBlend="BLEND",
			RAngle=90,
			DeepCheck=1,
			Top=0,
			Bottom=1,
			Left=0,
			Right=1,
			Anchor="CENTER",
			ToAnchor="CENTER",
			},


		["NameText_BorderData"]={
			OffsetX=0,
			OffsetY=10,
			Height=20,
			Width=140,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="Interface\\Tooltips\\UI-StatusBar-Border",
			TextureBlend="BLEND",
			Top=0,
			Bottom=1,
			Left=0,
			Right=1,
			RAngle=0,
			DeepCheck=1,
			Anchor="CENTER",
			ToAnchor="CENTER",
			},
	
	
		["NameText_BackgroundData"]={
			OffsetX=0,
			OffsetY=10,
			Height=20,
			Width=140,
			Red=0,
			Green=0,
			Blue=0,
			Alpha=0.5,
			Texture="Interface\\TargetingFrame\\UI-StatusBar",
			TextureBlend="BLEND",
			RAngle=0,
			DeepCheck=1,
			Top=0,
			Bottom=1,
			Left=0,
			Right=1,
			Anchor="CENTER",
			ToAnchor="CENTER",
			},

		["NameText_PortraitData"]={
			OffsetX=0,
			OffsetY=-50,
			Height=40,
			Width=40,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="",
			TextureBlend="BLEND",
			Left=0,
			Right=1,
			Top=0,
			Bottom=1,
			RAngle=0,
			DeepCheck=1,
			Anchor="CENTER",
			ToAnchor="CENTER",
			},
	

		["NameText_TextData"]={
			Font=GameFontNormal:GetFont(),
			OffsetX=0,
			OffsetY=10,
			ShadowX=1,
			ShadowY=-1,
			Size=11,
			Mode="OUTLINE",
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			DeepCheck=1,
			Anchor="CENTER",
			ToAnchor="CENTER",
			},

		["NameText_TextHostilePlayerData"]={
			Font=GameFontNormal:GetFont(),
			OffsetX=0,
			OffsetY=10,
			ShadowX=1,
			ShadowY=-1,
			Size=11,
			Mode="OUTLINE",
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			DeepCheck=1,
			Anchor="CENTER",
			ToAnchor="CENTER",
			},

		["NameText_TextFriendlyPlayerData"]={
			Font=GameFontNormal:GetFont(),
			OffsetX=0,
			OffsetY=10,
			ShadowX=1,
			ShadowY=-1,
			Size=11,
			Mode="OUTLINE",
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			DeepCheck=1,
			Anchor="CENTER",
			ToAnchor="CENTER",
			},
		["NameText_TextNeutralPlayerData"]={
			Font=GameFontNormal:GetFont(),
			OffsetX=0,
			OffsetY=10,
			ShadowX=1,
			ShadowY=-1,
			Size=11,
			Mode="OUTLINE",
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			DeepCheck=1,
			Anchor="CENTER",
			ToAnchor="CENTER",
			},

		["NameText_TextHostileNonPlayerData"]={
			Font=GameFontNormal:GetFont(),
			OffsetX=0,
			OffsetY=10,
			ShadowX=1,
			ShadowY=-1,
			Size=11,
			Mode="OUTLINE",
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			DeepCheck=1,
			Anchor="CENTER",
			ToAnchor="CENTER",
			},

		["NameText_TextFriendlyNonPlayerData"]={
			Font=GameFontNormal:GetFont(),
			OffsetX=0,
			OffsetY=10,
			ShadowX=1,
			ShadowY=-1,
			Size=11,
			Mode="OUTLINE",
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			DeepCheck=1,
			Anchor="CENTER",
			ToAnchor="CENTER",
			},
		["NameText_TextNeutralNonPlayerData"]={
			Font=GameFontNormal:GetFont(),
			OffsetX=0,
			OffsetY=10,
			ShadowX=1,
			ShadowY=-1,
			Size=11,
			Mode="OUTLINE",
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			DeepCheck=1,
			Anchor="CENTER",
			ToAnchor="CENTER",
			},

		["NameText_TextTappedData"]={
			Font=GameFontNormal:GetFont(),
			OffsetX=0,
			OffsetY=10,
			ShadowX=1,
			ShadowY=-1,
			Size=11,
			Mode="OUTLINE",
			Red=0.6,
			Green=0.6,
			Blue=0.6,
			Alpha=1,
			DeepCheck=1,
			Anchor="CENTER",
			ToAnchor="CENTER",
			},
		["NameText_TextPVPFriendlyData"]={
			Font=GameFontNormal:GetFont(),
			OffsetX=0,
			OffsetY=10,
			ShadowX=1,
			ShadowY=-1,
			Size=11,
			Mode="OUTLINE",
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			DeepCheck=1,
			Anchor="CENTER",
			ToAnchor="CENTER",
			},
		["NameText_TextPVPHostileData"]={
			Font=GameFontNormal:GetFont(),
			OffsetX=0,
			OffsetY=10,
			ShadowX=1,
			ShadowY=-1,
			Size=11,
			Mode="OUTLINE",
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			DeepCheck=1,
			Anchor="CENTER",
			ToAnchor="CENTER",
			},

		["NameText_GuildData"]={
			Font=GameFontNormal:GetFont(),
			OffsetX=0,
			OffsetY=0,
			ShadowX=1,
			ShadowY=-1,
			Size=11,
			Mode="OUTLINE",
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			DeepCheck=1,
			Anchor="CENTER",
			ToAnchor="CENTER",
			},
		["NameText_NPCGuildData"]={
			Font=GameFontNormal:GetFont(),
			OffsetX=0,
			OffsetY=0,
			ShadowX=1,
			ShadowY=-1,
			Size=11,
			Mode="OUTLINE",
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			DeepCheck=1,
			Anchor="CENTER",
			ToAnchor="CENTER",
			},

		["NameText_MarkData"]={
			OffsetX=0,
			OffsetY=70,
			Height=30,
			Width=30,
			Red=1,
			Green=1,
			Blue=1,
			Alpha=1,
			Texture="Interface\\Addons\\NPA\\texture\\animated\\star-white@11@11@50",
			TextureBlend="BLEND",
			Left=0,
			Right=1,
			Top=0,
			Bottom=1,
			RAngle=0,
			DeepCheck=1,
			Anchor="CENTER",
			ToAnchor="CENTER",
			},

	}
local NPA_NameText_Config=NPA_NameText_DefaultSetting

function NPA_NameText:ResetConfig()
	NPA_Config["NameText"]=CopyTable(NPA_NameText_DefaultSetting)
end



-- get global functions
local pairs = pairs
local floor = floor
local table_insert = table.insert
local unpack=unpack
local string_len=string.len
local string_sub=string.sub
local table_sort=table.sort
local strsplit=strsplit
-----------------
local NPA_NameText_Frame={}

local ManageTexture=NPA_Core.TextureManager2
local ManageFont=NPA_Core.FontManager

local BindPortrait=NPA_Core.BindPortrait
local UnbindPortrait=NPA_Core.UnbindPortrait

local NPA_NameText_HideFilter={}

--------------
local NPA_NameText_MainFuncList={}
local NPA_NameText_GetNameFuncList={}
local NPA_NameText_ColorFuncList={}
local NPA_NameText_MarkFuncList={}
local NPA_NameText_PortraitFuncList={}

local NPA_NameText_Length=0

local NPA_NameText_CustomTextFunc={Max=0}

local NPA_NameText_NPCGuildCache={}

local NPA_NameText_ColorTextFunc={
	[0]=function(_,_,default)
		if(default)then
			local r,g,b=default.HealthBar:GetStatusBarColor()
			return {r=r,g=g,b=b}
		end
	end,
	[1]=function(hostile)
		if(hostile==1)then
			return {r=1,g=0,b=0}
		elseif(hostile==2)then
			return {r=1,g=1,b=0}
		else
			return {r=0,g=1,b=0}
		end
	end,
	[2]=function(_,unitdata,default)
		if(unitdata and unitdata.IsPlayer==1)then
			return RAID_CLASS_COLORS[unitdata.ClassMark] or {r=0.5,b=0.5,g=0.5}
		elseif(default)then
			local r,g,b=default.HealthBar:GetStatusBarColor()
			return {r=r,g=g,b=b}
		end
	end
	}
local NPA_NameText_ColorTextFuncList={
	[0]={
		[0]=0,
		[1]=0,
		[2]=0,
		},
	[1]={
		[0]=0,
		[1]=0,
		[2]=0,
		},
	[2]={
		[0]=0,
		[1]=0,
		[2]=0,
		},
	}
local function NPA_NameText_BuildFuncList()
	NPA_NameText_MainFuncList={}
	NPA_NameText_GetNameFuncList={}
	NPA_NameText_ColorFuncList={}
	NPA_NameText_MarkFuncList={}
	NPA_NameText_PortraitFuncList={}
	----------
	-- index=[hostile][player/pvp]
	--1=by faction
	--2=by class
	--3=dont change
	

	if(NPA_NameText_Config["NameText_Name"]==1)then
		NPA_NameText_ColorTextFuncList={
			[0]={
				[0]=NPA_NameText_Config["NameText_ColorFriendlyNonPlayerData"],
				[1]=NPA_NameText_Config["NameText_ColorFriendlyPlayerData"],
				[2]=NPA_NameText_Config["NameText_ColorPvPFriendlyData"],
				},
			[1]={
				[0]=NPA_NameText_Config["NameText_ColorHostileNonPlayerData"],
				[1]=NPA_NameText_Config["NameText_ColorHostilePlayerData"],
				[2]=NPA_NameText_Config["NameText_ColorPvPHostileData"],
				},
			[2]={
				[0]=NPA_NameText_Config["NameText_ColorNeutralNonPlayerData"],
				[1]=NPA_NameText_Config["NameText_ColorNeutralPlayerData"],
				[2]=NPA_NameText_Config["NameText_ColorPvPNeutralData"],
				}
		}

		--------------------------
		if(NPA_NameText_Config["NameText_FullName"]==1)then
			NPA_NameText_GetNameFuncList=function(unitdata,default)
				if(unitdata and unitdata.PVPName)then
					return unitdata.PVPName
				elseif(unitdata)then
					return unitdata.Name
				elseif(default)then
					return default.NameText:GetText()
				else
					return "Unknow"
				end
			end
		else
			NPA_NameText_GetNameFuncList=function(unitdata,default)
				if(unitdata)then
					return unitdata.Name
				elseif(default)then
					return default.NameText:GetText()
				else
					return "Unknow"
				end
			end
		end
		--------------------

		if(NPA_NameText_Config["NameText_ColorTarget"]==1)then
			NPA_NameText_ColorFuncList["Target"]=function(guid,guids)
				if(guid==guids.Target)then
					return 1
				end
			end
		end
		if(NPA_NameText_Config["NameText_ColorMouseover"]==1)then
			NPA_NameText_ColorFuncList["Mouseover"]=function(guid,guids)
				if(guid==guids.Mouseover)then
					return 1
				end
			end
		end
		if(NPA_NameText_Config["NameText_ColorFocus"]==1)then
			NPA_NameText_ColorFuncList["Focus"]=function(guid,guids)
				if(guid==guids.Focus)then
					return 1
				end
			end
		end
		if(NPA_NameText_Config["NameText_Tapped"]==1)then
			NPA_NameText_ColorFuncList["Tapped"]=function(_,_,unitdata)
				if(unitdata and unitdata.Tapped)then
					return 2
				end
			end
		end
		
		-------------------
		if(NPA_NameText_Config["NameText_SeparateNameText"]==1)then
			local sortedtable=CopyTable(NPA_NameText_Config["NameText_CustomTextData"])
			for name,value in pairs(sortedtable)do
				if(name=="DeepCheck" or value==0)then
					sortedtable[name]=nil
				end
			end
			table_sort(sortedtable)

			NPA_NameText_CustomTextFunc={}

			local count=0

			for name,value in pairs(sortedtable) do
				count=count+1
				if(name=="HostilePlayer")then
					NPA_NameText_CustomTextFunc[value]=function(_,isplayer,hostile)
						if(isplayer==1 and hostile==1)then
							return NPA_NameText_Config["NameText_TextHostilePlayerData"]
						end
					end
				elseif(name=="FriendlyPlayer")then
					NPA_NameText_CustomTextFunc[value]=function(_,isplayer,hostile)
						if(isplayer==1 and hostile==0)then
							return NPA_NameText_Config["NameText_TextFriendlyPlayerData"]
						end
					end
				elseif(name=="NeutralPlayer")then
					NPA_NameText_CustomTextFunc[value]=function(_,isplayer,hostile)
						if(isplayer==1 and hostile==2)then
							return NPA_NameText_Config["NameText_TextNeutralPlayerData"]
						end
					end
				elseif(name=="HostileNonPlayer")then
					NPA_NameText_CustomTextFunc[value]=function(_,isplayer,hostile)
						if(isplayer~=1 and hostile==1)then
							return NPA_NameText_Config["NameText_TextHostileNonPlayerData"]
						end
					end
				elseif(name=="FriendlyNonPlayer")then
					NPA_NameText_CustomTextFunc[value]=function(_,isplayer,hostile)
						if(isplayer~=1 and hostile==0)then
							return NPA_NameText_Config["NameText_TextFriendlyNonPlayerData"]
						end
					end
				elseif(name=="NeutralNonPlayer")then
					NPA_NameText_CustomTextFunc[value]=function(_,isplayer,hostile)
						if(isplayer~=1 and hostile==2)then
							return NPA_NameText_Config["NameText_TextNeutralNonPlayerData"]
						end
					end
				elseif(name=="PVPHostile")then
					NPA_NameText_CustomTextFunc[value]=function(unitdata,isplayer,hostile)
						if(isplayer==1 and hostile==1 and unitdata and unitdata.IsPvP==nil)then
							return NPA_NameText_Config["NameText_TextPVPHostileData"]
						end
					end
				elseif(name=="PVPFriendly")then
					NPA_NameText_CustomTextFunc[value]=function(unitdata,isplayer,hostile)
						if(isplayer==1 and hostile==0 and unitdata and unitdata.IsPvP==nil)then
							return NPA_NameText_Config["NameText_TextPVPFriendlyData"]
						end
					end
				elseif(name=="PVPNeutral")then
					NPA_NameText_CustomTextFunc[value]=function(unitdata,isplayer,hostile)
						if(isplayer==1 and hostile==2 and unitdata and unitdata.IsPvP==nil)then
							return NPA_NameText_Config["NameText_TextPVPNeutralData"]
						end
					end
				elseif(name=="TappedMob")then
					NPA_NameText_CustomTextFunc[value]=function(unitdata)
						if(unitdata and unitdata.Tapped)then
							return NPA_NameText_Config["NameText_TextTappedData"]
						end
					end
				end
			end
			NPA_NameText_CustomTextFunc.Max=count+1
			NPA_NameText_CustomTextFunc[NPA_NameText_CustomTextFunc.Max]=function()
					return NPA_NameText_Config["NameText_TextData"]
				end
		else
 			NPA_NameText_CustomTextFunc={Max=0}
		end

	-----------------main
		NPA_NameText_MainFuncList["Main"]=function(self,unitdata,frame,default,isplayer,hostile,guid,guids)
			--nametext
			local show
			for _,func in pairs(NPA_NameText_HideFilter) do
				if(func(frame,hostile,isplayer,guid,guids))then
					show=1
					break
				end
			end

			local class=frame["ClassIcon"]
			if((frame.IsTracker or show==1) and  (not(NPA_NameText_Config["NameText_HideTotem"]==1 and class and class:IsShown() and class.IsTotem==1)))then
				local nametext=self.Name

				local ls=self.LastState
				local tapped,pvp
				if(unitdata)then
					tapped=unitdata.Tapped
					pvp=unitdata.IsPvP
				end

				if(ls.Hostile~=hostile or ls.IsPlayer~=isplayer or ls.Tapped~=tapped or ls.PvP~=pvp)then
					for i=1,NPA_NameText_CustomTextFunc.Max do
						if(NPA_NameText_CustomTextFunc[i])then
							local retdata=NPA_NameText_CustomTextFunc[i](unitdata,isplayer,hostile)
							if(retdata)then
								ManageFont(nil,nametext,retdata,self)
								break
							end
						end
					end
					ls.Hostile=hostile
					ls.IsPlayer=isplayer
					ls.Tapped=tapped
					ls.PvP=pvp
				end

				local colorplayer
				if(pvp==nil and isplayer==1)then
					colorplayer=2
				else
					colorplayer=isplayer
				end
				local index=NPA_NameText_ColorTextFuncList[hostile][colorplayer]
				local func=NPA_NameText_ColorTextFunc[index]
				local color
				if(func)then
					color=NPA_NameText_ColorTextFunc[index](hostile,unitdata,default) or {r=1,g=1,b=1}
				else
					color={r=1,g=1,b=1}
				end
				nametext:SetTextColor(color.r*nametext.R,color.g*nametext.G,color.b*nametext.B)

				local text=NPA_NameText_GetNameFuncList(unitdata,default)
		
				if(NPA_NameText_Config["NameText_LimitLength"]==1)then
					local length=string_len(text)
					if(length>NPA_NameText_Length)then
						text=string_sub(text,0,NPA_NameText_Length-length-3).."..."
					end
				end

				for _,func in pairs(NPA_NameText_ColorFuncList) do
					local ret=func(guid,guids,unitdata)
					if(ret==1)then
						text="|cffffff00"..text
						break
					elseif(ret==2)then
						text="|cff999999"..text
						break
					end
				end

				nametext:SetText(text)
				nametext:Show()
			else
				self.Name:Hide()
			end
		end
	end
	-------------pvp flag
	if(NPA_NameText_Config["NameText_ShowPVPFlag"]==1)then
		NPA_NameText_MainFuncList["PVPFlag"]=function(self,unitdata,_,_,isplayer)
			if(isplayer==1 and unitdata and unitdata.IsPvP)then
				self.PVPFlag:Show()
			else
				self.PVPFlag:Hide()
			end
		end
	end

	-------------------guild
	if(NPA_NameText_Config["NameText_Guild"]==1)then
		--																						self,unitdata,_,_,_,_,_,_,_,_,_,isinstance)
		NPA_NameText_MainFuncList["Guild"]=function(self,unitdata,_,_,_,_,_,_,_,_,_,isinstance,isguild)
			if(unitdata and unitdata.Guild and
				(NPA_NameText_Config["NameText_HideGuildInInstance"]~=1 or (isinstance~=1)) and
				(NPA_NameText_Config["NameText_AutoHideGuild"]~=1 or frame:GetAlpha()~=1))then

				local guildtext=self.Guild
				guildtext:SetText("<"..unitdata.Guild..">")
				if(isguild)then
					guildtext:SetTextColor(0.5*guildtext.R,guildtext.G,0.5*guildtext.B)
				else
					guildtext:SetTextColor(guildtext.R,guildtext.G,guildtext.B)
				end
				guildtext:Show()
			else
				self.Guild:Hide()
			end
		end
	end
	----------------npcguild
	if(NPA_NameText_Config["NameText_NPCGuild"]==1)then
		NPA_NameText_MainFuncList["NPCGuild"]=function(self,unitdata,_,default,_,_,_,_,_,_,_,isinstance)
			local name
			if(unitdata and unitdata.Name)then
				name=unitdata.Name
			elseif(default)then
				name=default.NameText:GetText()
			end
			 if(name and 
				(NPA_NameText_Config["NameText_HideGuildInInstance"]~=1 or (isinstance~=1)) and
				(NPA_NameText_Config["NameText_AutoHideGuild"]~=1 or frame:GetAlpha()~=1))then

				local guild=NPA_NameText_NPCGuildCache[name]
				if(guild)then
					local guildtext=self.NPCGuild
					guildtext:SetText("<"..guild..">")
					guildtext:Show()
				else
					self.NPCGuild:Hide()
				end
			else
				self.NPCGuild:Hide()
			end
		end
	end
	-----------------mark
	if(NPA_NameText_Config["NameText_Mark"]==1)then

		if(NPA_NameText_Config["NameText_MarkTarget"]==1)then
			NPA_NameText_MarkFuncList["Target"]=function(mark,guid,guids)
				if(guid==guids.Target)then
					if(NPA_NameText_Config["NameText_MarkColorByType"]==1)then
						mark:SetVertexColor(mark.R,0,0)
					else
						mark:SetVertexColor(mark.R,mark.G,mark.B)
					end
					mark:Show()
					return 1
				end
			end
		end
		
		if(NPA_NameText_Config["NameText_MarkMouseover"]==1)then
			NPA_NameText_MarkFuncList["Mouseover"]=function(mark,guid,guids)
				if(guid==guids.Mouseover)then
					if(NPA_NameText_Config["NameText_MarkColorByType"]==1)then
						mark:SetVertexColor(mark.R*0.6,mark.G*0.6,0)
					else
						mark:SetVertexColor(mark.R,mark.G,mark.B)
					end
					mark:Show()
					return 1
				end
			end
		end

		if(NPA_NameText_Config["NameText_MarkFocus"]==1)then
			NPA_NameText_MarkFuncList["Focus"]=function(mark,guid,guids)
				if(guid==guids.Focus)then
					if(NPA_NameText_Config["NameText_MarkColorByType"]==1)then
						mark:SetVertexColor(mark.R,mark.G,0)
					else
						mark:SetVertexColor(mark.R,mark.G,mark.B)
					end
					mark:Show()
					return 1
				end
			end
		end

		if(NPA_NameText_Config["NameText_MarkFriend"]==1)then
			NPA_NameText_MarkFuncList["Friend"]=function(mark,_,_,_,isfriend)
				if(isfriend)then
					if(NPA_NameText_Config["NameText_MarkColorByType"]==1)then
						mark:SetVertexColor(0,mark.G,mark.B)
					else
						mark:SetVertexColor(mark.R,mark.G,mark.B)
					end
					mark:Show()
					return 1
				end
			end
		end

		if(NPA_NameText_Config["NameText_MarkPartyMember"]==1)then
			NPA_NameText_MarkFuncList["Party"]=function(mark,_,_,_,_,isparty,israid)
				if(isparty and
					(NPA_NameText_Config["NameText_MarkPartyAsRaid"]~=1 or (not israid)))then
					
					if(NPA_NameText_Config["NameText_MarkColorByType"]==1)then
						mark:SetVertexColor(0,0,mark.B)
					else
						mark:SetVertexColor(mark.R,mark.G,mark.B)
					end
					mark:Show()
					return 1
				end
			end
		end
		if(NPA_NameText_Config["NameText_MarkRaidMember"]==1)then
			NPA_NameText_MarkFuncList["Raid"]=function(mark,_,_,_,_,_,israid)
				if(israid)then
					if(NPA_NameText_Config["NameText_MarkColorByType"]==1)then
						mark:SetVertexColor(mark.R,0.5*mark.G,0)
					else
						mark:SetVertexColor(mark.R,mark.G,mark.B)
					end
					mark:Show()
					return 1
				end
			end
		end
		if(NPA_NameText_Config["NameText_MarkGuildMember"]==1)then
			NPA_NameText_MarkFuncList["Guild"]=function(mark,_,_,_,_,_,_,isguild)
				if(isguild)then
					if(NPA_NameText_Config["NameText_MarkColorByType"]==1)then
						mark:SetVertexColor(0,mark.G,0)
					else
						mark:SetVertexColor(mark.R,mark.G,mark.B)
					end
					mark:Show()
					return 1
				end
			end
		end

		------------
		NPA_NameText_MainFuncList["Mark"]=function(self,unitdata,_,_,isplayer,hostile,guid,guids,isfriend,isparty,israid,isinstance)
			if((isinstance~=1) or NPA_NameText_Config["NameText_MarkHideInInstance"]~=1)then
				local mark=self.Mark
				mark:Hide()
				for _,func in pairs(NPA_NameText_MarkFuncList) do
					if(func(mark,guid,guids,isplayer,isfriend,isparty,israid,isguild)==1)then
						break
					end
				end
			end
		end
	end
	------------------------------portrait
	if(NPA_NameText_Config["NameText_ShowPortrait"]==1)then
		if(NPA_NameText_Config["NameText_ShowHostilePortrait"]==1)then
			NPA_NameText_PortraitFuncList["Hostile"]=function(hostile)
				if(hostile==1)then
					return 1
				end
			end
		end
		
		if(NPA_NameText_Config["NameText_ShowNonHostilePortrait"]==1)then
			NPA_NameText_PortraitFuncList["NonHostile"]=function(hostile,isparty,israid,isguild)
				if(hostile~=1 and (not isparty) and (not israid) and (not isguild))then
					return 1
				end
			end
		end

		if(NPA_NameText_Config["NameText_ShowPartyPortrait"]==1)then
			NPA_NameText_PortraitFuncList["Party"]=function(_,isparty)
				if(isparty)then
					return 1
				end
			end
		end
		
		if(NPA_NameText_Config["NameText_ShowRaidPortrait"]==1)then
			NPA_NameText_PortraitFuncList["Raid"]=function(_,_israid)
				if(israid)then
					return 1
				end
			end
		end
		
		if(NPA_NameText_Config["NameText_ShowGuildPortrait"]==1)then
			NPA_NameText_PortraitFuncList["Guild"]=function(_,_,_,isguid)
				if(isguid)then
					return 1
				end
			end
		end

		if(NPA_NameText_Config["NameText_ShowTargetPortrait"]==1)then
			NPA_NameText_PortraitFuncList["Target"]=function(_,_,_,_,guid,guids)
				if(guid==guids.Target)then
					return 1
				end
			end
		end
		if(NPA_NameText_Config["NameText_ShowFocusPortrait"]==1)then
			NPA_NameText_PortraitFuncList["Focus"]=function(_,_,_,_,guid,guids)
				if(guid==guids.Focus)then
					return 1
				end
			end
		end
		if(NPA_NameText_Config["NameText_ShowMouseoverPortrait"]==1)then
			NPA_NameText_PortraitFuncList["Mouseover"]=function(_,_,_,_,guid,guids)
				if(guid==guids.Mouseover)then
					return 1
				end
			end
		end

		NPA_NameText_MainFuncList["Portrait"]=function(self,unitdata,_,_,isplayer,hostile,guid,guids,isfriend,isparty,israid)
			if(unitdata and (isplayer==1 or NPA_NameText_Config["NameText_ShowOnlyPlayerPortrait"]~=1))then
				local show
				for _,func in pairs(NPA_NameText_PortraitFuncList)do
					if(func(hostile,isparty,israid,isguild,guid,guids)==1)then
						show=1
						break
					end
				end

				if(show==1)then
					BindPortrait(guid,unitdata.Portrait,self,NPA_NameText_Config["NameText_PortraitData"])
				else
					UnbindPortrait(self)
				end
			else
				UnbindPortrait(self)
			end
		end
	end

end


--main


local function NPA_NameText_OnUpdate(_,self,guid,unitdata,_,guids,frame,hostile,isplayer,default,recentUpdated,_,isfriend,isguild,isparty,israid,isinstance)
	if(NPA_NameText_Config["NameText_HideWithHealthBar"]==1)then
		local healthbar=frame["HealthBar"]
		if(not (healthbar and healthbar:IsShown()))then
			self:Hide()
			return
		end
	end

	--alpha
	if((not default) or 
		(NPA_NameText_Config["NameText_BoldHostile"]==1 and hostile==1) or
		(NPA_NameText_Config["NameText_BoldNeutral"]==1 and hostile==2) or
		(NPA_NameText_Config["NameText_BoldNonHostile"]==1 and hostile==0))then
	
		self:SetAlpha(1)
	else
		self:SetAlpha(frame:GetAlpha())
	end

	for _,func in pairs(NPA_NameText_MainFuncList) do
		func(self,unitdata,frame,default,isplayer,hostile,guid,guids,isfriend,isparty,israid,isinstance,isguild)
	end

	self:SetScale(frame:GetScale())
	self:Show()
end



local function NPA_NameText_SetFrame(frame)
	frame.LastState={
		Hostile=-1,
		IsPlayer=-1,
		PvP=-1,
		Tapped=-1}

	frame:Hide()
	local nametext=frame.Name

	ManageFont(nil,frame.Name,NPA_NameText_Config["NameText_TextData"],frame)
	ManageFont(nil,frame.Guild,NPA_NameText_Config["NameText_GuildData"],frame)
	ManageFont(nil,frame.NPCGuild,NPA_NameText_Config["NameText_NPCGuildData"],frame)
	ManageTexture(nil,frame.Mark,NPA_NameText_Config["NameText_MarkData"],frame)
	ManageTexture(nil,frame.PVPFlag,NPA_NameText_Config["NameText_PVPFlagData"],frame)

	ManageTexture(nil,frame.Border,NPA_NameText_Config["NameText_BorderData"],frame)
	ManageTexture(nil,frame.Background,NPA_NameText_Config["NameText_BackgroundData"],frame)

	if(NPA_NameText_Config["NameText_ShowBorder"]==1)then
		frame.Border:Show()
	else
		frame.Border:Hide()
	end

	if(NPA_NameText_Config["NameText_ShowBackground"]==1)then
		frame.Background:Show()
	else
		frame.Background:Hide()
	end

	frame.Name:Hide()
	frame.Guild:Hide()
	frame.NPCGuild:Hide()
	frame.Mark:Hide()
	frame.PVPFlag:Hide()

	UnbindPortrait(frame)

end



local function NPA_NameText_HookFrame(frame)
	local nametextframe=CreateFrame("Frame","NPA_NameText_LayerFrame",frame:GetParent())
	nametextframe:SetPoint("CENTER",frame,"CENTER")
	nametextframe:SetWidth(1)
	nametextframe:SetHeight(1)
	nametextframe:Show()

	--nametextframe:SetFrameStrata("TOOLTIP")

	local nametext=nametextframe:CreateFontString("NPA_NameText_Name","ARTWORK",nil)
	local guildtext=nametextframe:CreateFontString("NPA_NameText_Guild","ARTWORK",nil)
	local npcguildtext=nametextframe:CreateFontString("NPA_NameText_NPCGuild","ARTWORK",nil)
	local mark=nametextframe:CreateTexture("NPA_NameText_Mark","BORDER",nil)

	local border=nametextframe:CreateTexture("NPA_HealthBar_Border","OVERLAY",nil)
	local background=nametextframe:CreateTexture("NPA_HealthBar_Background","BACKGROUND",nil)
	
	local pvpflag=nametextframe:CreateTexture("NPA_NameText_PvPFlag","BORDER",nil)

	nametextframe.Border=border
	nametextframe.Background=background

	nametextframe.Name=nametext
	nametextframe.Guild=guildtext
	nametextframe.NPCGuild=npcguildtext
	nametextframe.Mark=mark
	nametextframe.Portrait=nil
	
	nametextframe.PVPFlag=pvpflag

	nametextframe.Parent=frame
	nametextframe:Hide()

	nametextframe:HookScript("OnHide",function(self)
		if(self.Portrait)then
			self.Portrait:Hide()
			self.Portrait=nil
		end
		end)


	table_insert(NPA_NameText_Frame,nametextframe)

	NPA_NameText_SetFrame(nametextframe)
	
	frame["NameText"]=nametextframe
	
	return framedata
end

local function NPA_NameText_BuildHideFilter()
	NPA_NameText_HideFilter={}

	if(NPA_NameText_Config["NameText_HostilePlayerName"]==1)then
		NPA_NameText_HideFilter["HostilePlayerName"]=function(_,hostile,isplayer)
				if(isplayer==1 and hostile==1)then
					return 1
				end
			end
	end
	
	if(NPA_NameText_Config["NameText_NeutralPlayerName"]==1)then
		NPA_NameText_HideFilter["NeutralPlayerName"]=function(_,hostile,isplayer)
				if(isplayer==1 and hostile==2)then
					return 1
				end
			end
	end

	if(NPA_NameText_Config["NameText_FriendlyPlayerName"]==1)then
		NPA_NameText_HideFilter["FriendlyPlayerName"]=function(_,hostile,isplayer)
				if(isplayer==1 and hostile==0)then
					return 1
				end
			end
	end

	if(NPA_NameText_Config["NameText_HostileNonPlayerName"]==1)then
		NPA_NameText_HideFilter["HostileNonPlayerName"]=function(_,hostile,isplayer)
				if(isplayer==0 and hostile==1)then
					return 1
				end
			end
	end
	
	if(NPA_NameText_Config["NameText_NeutralNonPlayerName"]==1)then
		NPA_NameText_HideFilter["NeutralNonPlayerName"]=function(_,hostile,isplayer)
				if(isplayer==0 and hostile==2)then
					return 1
				end
			end
	end

	if(NPA_NameText_Config["NameText_FriendlyNonPlayerName"]==1)then
		NPA_NameText_HideFilter["FriendlyNonPlayerName"]=function(_,hostile,isplayer)
				if(isplayer==0 and hostile==0)then
					return 1
				end
			end
	end


	if(NPA_NameText_Config["NameText_QuestUnitName"]==1)then
		NPA_NameText_HideFilter["QuestUnitName"]=function(frame)
				local questmark=frame["QuestMark"]
				if(questmark and questmark:IsShown())then
					return 1
				end
			end
	end

	if(NPA_NameText_Config["NameText_TargetName"]==1)then
		NPA_NameText_HideFilter["TargetName"]=function(_,_,_,guid,guids)
				if(guid==guids.Target)then
					return 1
				end
			end
	end
	if(NPA_NameText_Config["NameText_FocusName"]==1)then
		NPA_NameText_HideFilter["FocusName"]=function(_,_,_,guid,guids)
				if(guid==guids.Focus)then
					return 1
				end
			end
	end

	if(NPA_NameText_Config["NameText_MouseoverName"]==1)then
		NPA_NameText_HideFilter["MouseoverName"]=function(_,_,_,guid,guids)
				if(guid==guids.Mouseover)then
					return 1
				end
			end
	end
end


local function NPA_NameText_NPCGuildScan(unit)
	if((not UnitPlayerControlled(unit)) and UnitName(unit))then
		local text=NPAScanTooltipTextLeft3:GetText()
        if(text)then
			_,text=strsplit(" ",text)
			if(text=="??" or tonumber(text))then
				NPA_NameText_NPCGuildCache[UnitName(unit)]=NPAScanTooltipTextLeft2:GetText()
			--else
			--	text=NPAScanTooltipTextLeft2:GetText()
			--	_,text=strsplit(" ",text)
			--	string_sub(text,2,2)
			--	print(text)
			--	if(text=="??" or tonumber(text))then
			--		print(NPAScanTooltipTextLeft3:GetText())
			--	end
			end
		end
	end
end

function NPA_NameText:ApplyConfig()
	NPA_Core:CheckConfigEntry("NameText",NPA_NameText_DefaultSetting)

	NPA_NameText_Config=NPA_Config["NameText"]

	for _,frame in pairs(NPA_NameText_Frame) do
		NPA_NameText_SetFrame(frame)
	end


	if(NPA_NameText_Config["NameText_ShowPortrait"]==1)then
		NPA_Core:RequestPortrait("NameText")
	else
		NPA_Core:UnrequestPortrait("NameText")
	end

	NPA_NameText_BuildHideFilter()
	NPA_NameText_BuildFuncList()

	NPA_NameText_Length=floor(NPA_NameText_Config["NameText_Length"])

	if(NPA_NameText_Config["NameText_NPCGuild"]==1)then
		NPA_Core.TooltipsScanFunc["NPCGuild"]=NPA_NameText_NPCGuildScan
	else
		NPA_Core.TooltipsScanFunc["NPCGuild"]=nil
	end

end

function NPA_NameText:RequireDataCollet()
	NPA_Core.Data_Filter["Class"]=1
	NPA_Core.Data_Filter["NameGuild"]=1
	NPA_Core.Data_Filter["Tapped"]=1
end

NPA_Core:AddHook("NameText",NPA_NameText_HookFrame)
NPA_Core:AddModule("NameText",NPA_NameText)
NPA_Core:HookUpdate("NameText",NPA_NameText_OnUpdate,1)
