﻿-- Author      : Nogarder
-- Create Date : 2010/7/4 16:33:11

if(NPA_Core:CheckHook("Tracker"))then

local Localization={}
local locale=GetLocale()
local table_insert = table.insert
local pairs = pairs
local Tooltips={}

if(locale=="zhTW")then
	Localization={
		["PageName"]="追踪",
		["Apply"]="套用",
		["Reset"]="重置",
		["Cancel"]="撤銷",
		["UpdateInterval"]="更新間隔(秒)",
		["OffsetX"]="X偏移",
		["OffsetY"]="Y偏移",
		["Size"]="尺寸",
		["Count"]="最大數量",
		["Row"]="每行數量",
		["Filter"]="過濾",
		["LeftWard"]="向左增長",
		["UpWard"]="向上增長",
		["Hostile"]="敵對",
		["NonHostile"]="非敵對",
		["Cast"]="正在施法",
		["HasAura"]="有buff/debuff",
		["IsCastOnMe"]="正在對我施法",
		["FrameUpdateInterval"]="框架更新間隔 (秒)",
		["Width"]="行間距",
		["Height"]="列間距",
		["HasCrowdControl"]="有控場提示",
		["TimeOut"]="超時 (秒)",
		["HasCounterSpell"]="有反制提示",
		["HasCoolDown"]="有技能冷卻",
		["ModuleList"]="追踪框體模塊(需要重載ui)",

		["Self"]="顯示自己",
		["SelfOffsetX"]="自身框體X偏移",
		["SelfOffsetY"]="自身框體Y偏移",
		["SelfSize"]="自身框體尺寸",
		["SelfName"]="顯示名字",
		["SelfAlpha"]="自身框體透明度",
		["SelfEnableMouse"]="啟用鼠標",
		["SelfModuleList"]="自身框體模塊(需要重載ui)",

		["Pet"]="顯示寵物",
		["PetOffsetX"]="玩家寵物框體X偏移",
		["PetOffsetY"]="玩家寵物框體Y偏移",
		["PetSize"]="玩家寵物框體尺寸",
		["PetName"]="顯示名字",
		["PetAlpha"]="玩家寵物框體透明度",
		["PetEnableMouse"]="啟用鼠標",
		["PetModuleList"]="寵物框體模塊(需要重載ui)",

		["Focus"]="顯示Focus",
		["FocusOffsetX"]="玩家Focus框體X偏移",
		["FocusOffsetY"]="玩家Focus框體Y偏移",
		["FocusSize"]="玩家Focus框體尺寸",
		["FocusName"]="顯示名字",
		["FocusAlpha"]="玩家Focus框體透明度",
		["FocusEnableMouse"]="啟用鼠標",
		["FocusModuleList"]="Focus框體模塊(需要重載ui)",

		["Target"]="顯示目標",
		["TargetOffsetX"]="玩家目標框體X偏移",
		["TargetOffsetY"]="玩家目標框體Y偏移",
		["TargetSize"]="玩家目標框體尺寸",
		["TargetName"]="顯示名字",
		["TargetAlpha"]="玩家目標框體透明度",
		["TargetEnableMouse"]="啟用鼠標",
		["TargetModuleList"]="目標框體模塊(需要重載ui)",

		["Aura"]="增減益",
		["AutoHide"]="自動隱藏",
		["CastWarning"]="施法警告",
		["ClassIcon"]="職業圖標",
		["ComboPoint"]="連擊點數",
		["CoolDown"]="技能冷卻",
		["CrowdControl"]="控場提示",
		["HealthBar"]="生命條",
		["ManaBar"]="法力條",
		["QuestMark"]="任務指示",
		["RaidIcon"]="團隊標記",
		["ScrollText"]="戰鬥文字",
		["Speed"]="移動速度",
		["Target"]="目標",
		["Threat"]="仇恨",
		["Tracker"]="追踪",
		["ClassInfo"]="職業信息",
		["NameText"]="名稱文本",
		["exCombat"]="脫離戰鬥",
		["RangeCheck"]="距離檢測",
		["CounterSpell"]="法術反制",
		["RoleCheck"]="職位檢查",
		["TargetCount"]="目標計數",
		["ShieldWatch"]="護盾監視",

		["RegisterGUID"]="註冊GUID(啟用戰鬥文本模塊)"

	}
	Tooltips={
		["Tracker"]="顯示屏幕外單位的姓名板,自己,寵物,Focus和目標的姓名板,",
		["Count"]="這項設為0則關閉"
	}
elseif(locale=="zhCN")then
	Localization={
		["PageName"]="追踪",
		["Apply"]="套用",
		["Reset"]="重置",
		["Cancel"]="撤销",
		["UpdateInterval"]="更新间隔(秒)",
		["OffsetX"]="X偏移",
		["OffsetY"]="Y偏移",
		["Size"]="尺寸",
		["Count"]="最大数量",
		["Row"]="每行数量",
		["Filter"]="过滤",
		["LeftWard"]="向左增长",
		["UpWard"]="向上增长",
		["Hostile"]="敌对",
		["NonHostile"]="非敌对",
		["Cast"]="正在施法",
		["HasAura"]="有buff/debuff",
		["IsCastOnMe"]="正在对我施法",
		["FrameUpdateInterval"]="框架更新间隔 (秒)",
		["Width"]="行间距",
		["Height"]="列间距",
		["HasCrowdControl"]="有控场提示",
		["TimeOut"]="超时 (秒)",
		["HasCounterSpell"]="有反制提示",
		["HasCoolDown"]="有技能冷却",
		["ModuleList"]="追踪框体模块(需要重载ui)",

		["Self"]="显示自己",
		["SelfOffsetX"]="自身框体X偏移",
		["SelfOffsetY"]="自身框体Y偏移",
		["SelfSize"]="自身框体尺寸",
		["SelfName"]="显示名字",
		["SelfAlpha"]="自身框体透明度",
		["SelfEnableMouse"]="启用鼠标",
		["SelfModuleList"]="自身框体模块(需要重载ui)",

		["Pet"]="显示宠物",
		["PetOffsetX"]="玩家宠物框体X偏移",
		["PetOffsetY"]="玩家宠物框体Y偏移",
		["PetSize"]="玩家宠物框体尺寸",
		["PetName"]="显示名字",
		["PetAlpha"]="玩家宠物框体透明度",
		["PetEnableMouse"]="启用鼠标",
		["PetModuleList"]="宠物框体模块(需要重载ui)",

		["Focus"]="显示Focus",
		["FocusOffsetX"]="玩家Focus框体X偏移",
		["FocusOffsetY"]="玩家Focus框体Y偏移",
		["FocusSize"]="玩家Focus框体尺寸",
		["FocusName"]="显示名字",
		["FocusAlpha"]="玩家Focus框体透明度",
		["FocusEnableMouse"]="启用鼠标",
		["FocusModuleList"]="Focus框体模块(需要重载ui)",

		["Target"]="显示目标",
		["TargetOffsetX"]="玩家目标框体X偏移",
		["TargetOffsetY"]="玩家目标框体Y偏移",
		["TargetSize"]="玩家目标框体尺寸",
		["TargetName"]="显示名字",
		["TargetAlpha"]="玩家目标框体透明度",
		["TargetEnableMouse"]="启用鼠标",
		["TargetModuleList"]="目标框体模块(需要重载ui)",

		["Aura"]="增减益",
		["AutoHide"]="自动隐藏",
		["CastWarning"]="施法警告",
		["ClassIcon"]="职业图标",
		["ComboPoint"]="连击点数",
		["CoolDown"]="技能冷却",
		["CrowdControl"]="控场提示",
		["HealthBar"]="生命条",
		["ManaBar"]="法力条",
		["QuestMark"]="任务指示",
		["RaidIcon"]="团队标记",
		["ScrollText"]="战斗文字",
		["Speed"]="移动速度",
		["Target"]="目标",
		["Threat"]="仇恨",
		["RangeCheck"]="距离检测",
		["Tracker"]="追踪",
		["CounterSpell"]="法术反制",
		["NameText"]="名称文本",
		["TargetCount"]="目标计数",
		["ShieldWatch"]="护盾监视",
		["RoleCheck"]="职位检查",
		["exCombat"]="脱离战斗",
		["ClassInfo"]="职业信息",

		["RegisterGUID"]="注册GUID(启用战斗文本模块)"

	}
	Tooltips={
		["Tracker"]="显示屏幕外单位的姓名板,自己,宠物,Focus和目标的姓名板",
		["Count"]="这项设为0则关闭"
	}
else
	Localization={
		["PageName"]="Tracker",
		["Apply"]="Apply",
		["Reset"]="Reset",
		["Cancel"]="Cancel",
		["UpdateInterval"]="Tracker update interval (Second)",
		["OffsetX"]="Offset X",
		["OffsetY"]="Offset Y",
		["Size"]="Size",
		["Count"]="Max tracker number",
		["Row"]="Max tracker per row",
		["Filter"]="Filter",
		["LeftWard"]="Grow leftward",
		["UpWard"]="Grow upward",
		["Hostile"]="Show hostile",
		["NonHostile"]="Show non-hostile",
		["Cast"]="Is casting",
		["HasAura"]="Has aura",
		["IsCastOnMe"]="Is casting on me",
		["FrameUpdateInterval"]="Frame update interval (Second)",
		["Width"]="Row gap",
		["Height"]="Column gap",
		["HasCrowdControl"]="Has crowd control",
		["TimeOut"]="Time out (Second)",
		["HasCounterSpell"]="Has counterspell",
		["HasCoolDown"]="Has cooldown",

		["ModuleList"]="Tracker frame module(require ui reload)",

		["Self"]="Show SelfFrame",
		["SelfOffsetX"]="Self frame offset X",
		["SelfOffsetY"]="Self frame offset Y",
		["SelfSize"]="Self frame Size",
		["SelfName"]="Show Name",
		["SelfAlpha"]="Self frame alpha",
		["SelfEnableMouse"]="Enable mouse",
		["SelfModuleList"]="Self frame module(require ui reload)",

		["Pet"]="Show PetFrame",
		["PetOffsetX"]="Pet frame offset X",
		["PetOffsetY"]="Pet frame offset Y",
		["PetSize"]="Pet frame Size",
		["PetName"]="Show Name",
		["PetAlpha"]="Pet frame alpha",
		["PetEnableMouse"]="Enable mouse",
		["PetModuleList"]="Pet frame module(require ui reload)",

		["Focus"]="Show FocusFrame",
		["FocusOffsetX"]="Focus frame offset X",
		["FocusOffsetY"]="Focus frame offset Y",
		["FocusSize"]="Focus frame Size",
		["FocusName"]="Show Name",
		["FocusAlpha"]="Focus frame alpha",
		["FocusEnableMouse"]="Enable mouse",
		["FocusModuleList"]="Focus frame module(require ui reload)",

		["Target"]="Show TargetFrame",
		["TargetOffsetX"]="Target frame offset X",
		["TargetOffsetY"]="Target frame offset Y",
		["TargetSize"]="Target frame Size",
		["TargetName"]="Show Name",
		["TargetAlpha"]="Target frame alpha",
		["TargetEnableMouse"]="Enable mouse",
		["TargetModuleList"]="Target frame module(require ui reload)",

		["Aura"]="Aura",
		["AutoHide"]="AutoHide",
		["CastWarning"]="CastWarning",
		["ClassIcon"]="ClassIcon",
		["ComboPoint"]="ComboPoint",
		["CoolDown"]="CoolDown",
		["CrowdControl"]="CrowdControl",
		["HealthBar"]="HealthBar",
		["ManaBar"]="ManaBar",
		["QuestMark"]="QuestMark",
		["RaidIcon"]="RaidIcon",
		["ScrollText"]="ScrollText",
		["Speed"]="Speed",
		["Target"]="Target",
		["Threat"]="Threat",
		["RangeCheck"]="RangeCheck",
		["Tracker"]="Tracker",
		["CounterSpell"]="CounterSpell",
		["ClassInfo"]="ClassInfo",
		["NameText"]="NameText",
		["TargetCount"]="TargetCount",
		["ShieldWatch"]="ShieldWatch",
		["RoleCheck"]="RoleCheck",
		["exCombat"]="exCombat",

		["RegisterGUID"]="Register GUID(Enable [ScrollText])"

	}
	Tooltips={
		["Tracker"]="Shows nameplates for unit outside of screen, self,pet,focus and target",
		["Count"]="Set this 0 to turn off"
	}
end


local mainframe=NPA_Options:AddPage("NPA_Options_Tracker",Localization["PageName"],"Tracker",Tooltips["Tracker"])

local Options=mainframe.Options



local sliderlist={
	["Tracker_UpdateInterval"]={
		Name=Localization["UpdateInterval"],
		Min=0.1,
		Max=3,
		Step=0.1,
		Width=142,
		OffsetX=20,
		OffsetY=-10
	},

	["Tracker_Frame_UpdateInterval"]={
		Name=Localization["FrameUpdateInterval"],
		Min=0.1,
		Max=3,
		Step=0.1,
		Width=142,
		OffsetX=175,
		OffsetY=-10
	},

	["Tracker_OffsetX"]={
		Name=Localization["OffsetX"],
		Min=-450,
		Max=450,
		Step=1,
		Width=142,
		OffsetX=20,
		OffsetY=-50
	},
	["Tracker_OffsetY"]={
		Name=Localization["OffsetY"],
		Min=-450,
		Max=450,
		Step=1,
		Width=142,
		OffsetX=175,
		OffsetY=-50
	},

	["Tracker_Size"]={
		Name=Localization["Size"],
		Min=0.1,
		Max=3,
		Step=0.1,
		Width=142,
		OffsetX=20,
		OffsetY=-90
	},

	["Tracker_Count"]={
		Name=Localization["Count"],
		Min=0,
		Max=20,
		Step=1,
		Width=142,
		OffsetX=175,
		OffsetY=-90
	},

	["Tracker_Row"]={
		Name=Localization["Row"],
		Min=1,
		Max=10,
		Step=1,
		Width=142,
		OffsetX=20,
		OffsetY=-130
	},

	["Tracker_Height"]={
		Name=Localization["Height"],
		Min=1,
		Max=400,
		Step=1,
		Width=142,
		OffsetX=20,
		OffsetY=-170
	},

	["Tracker_Width"]={
		Name=Localization["Width"],
		Min=1,
		Max=400,
		Step=1,
		Width=142,
		OffsetX=175,
		OffsetY=-170
	},

	["Tracker_TimeOut"]={
		Name=Localization["TimeOut"],
		Min=1,
		Max=360,
		Step=1,
		Width=142,
		OffsetX=20,
		OffsetY=-210
	},


	["Tracker_SelfOffsetX"]={
		Name=Localization["SelfOffsetX"],
		Min=-450,
		Max=450,
		Step=1,
		Width=122,
		OffsetX=20,
		OffsetY=-290
	},

	["Tracker_SelfOffsetY"]={
		Name=Localization["SelfOffsetY"],
		Min=-450,
		Max=450,
		Step=1,
		Width=122,
		OffsetX=165,
		OffsetY=-290
	},
	["Tracker_SelfSize"]={
		Name=Localization["SelfSize"],
		Min=1,
		Max=5,
		Step=0.1,
		Width=122,
		OffsetX=310,
		OffsetY=-290
	},

	["Tracker_SelfAlpha"]={
		Name=Localization["SelfAlpha"],
		Min=0.1,
		Max=1,
		Step=0.1,
		Width=122,
		OffsetX=455,
		OffsetY=-290
	},


	["Tracker_PetOffsetX"]={
		Name=Localization["PetOffsetX"],
		Min=-450,
		Max=450,
		Step=1,
		Width=122,
		OffsetX=20,
		OffsetY=-360
	},

	["Tracker_PetOffsetY"]={
		Name=Localization["PetOffsetY"],
		Min=-450,
		Max=450,
		Step=1,
		Width=122,
		OffsetX=165,
		OffsetY=-360
	},
	["Tracker_PetSize"]={
		Name=Localization["PetSize"],
		Min=1,
		Max=5,
		Step=0.1,
		Width=122,
		OffsetX=310,
		OffsetY=-360
	},

	["Tracker_PetAlpha"]={
		Name=Localization["PetAlpha"],
		Min=0.1,
		Max=1,
		Step=0.1,
		Width=122,
		OffsetX=455,
		OffsetY=-360
	},

	["Tracker_FocusOffsetX"]={
		Name=Localization["FocusOffsetX"],
		Min=-450,
		Max=450,
		Step=1,
		Width=122,
		OffsetX=20,
		OffsetY=-430
	},

	["Tracker_FocusOffsetY"]={
		Name=Localization["FocusOffsetY"],
		Min=-450,
		Max=450,
		Step=1,
		Width=122,
		OffsetX=165,
		OffsetY=-430
	},
	["Tracker_FocusSize"]={
		Name=Localization["FocusSize"],
		Min=1,
		Max=5,
		Step=0.1,
		Width=122,
		OffsetX=310,
		OffsetY=-430
	},

	["Tracker_FocusAlpha"]={
		Name=Localization["FocusAlpha"],
		Min=0.1,
		Max=1,
		Step=0.1,
		Width=122,
		OffsetX=455,
		OffsetY=-430
	},

	["Tracker_TargetOffsetX"]={
		Name=Localization["TargetOffsetX"],
		Min=-450,
		Max=450,
		Step=1,
		Width=122,
		OffsetX=20,
		OffsetY=-500
	},

	["Tracker_TargetOffsetY"]={
		Name=Localization["TargetOffsetY"],
		Min=-450,
		Max=450,
		Step=1,
		Width=122,
		OffsetX=165,
		OffsetY=-500
	},
	["Tracker_TargetSize"]={
		Name=Localization["TargetSize"],
		Min=1,
		Max=5,
		Step=0.1,
		Width=122,
		OffsetX=310,
		OffsetY=-500
	},

	["Tracker_TargetAlpha"]={
		Name=Localization["TargetAlpha"],
		Min=0.1,
		Max=1,
		Step=0.1,
		Width=122,
		OffsetX=455,
		OffsetY=-500
	},
}


NPA_Options:BuildSliderList("NPA_Options_Tracker",mainframe,sliderlist,Options,tooltipslist)



local checkbox=NPA_Options:CreateCheckBox("NPA_Options_Tracker_Self",mainframe,21,Localization["Self"],"Tracker_Self")
checkbox:SetPoint("TOPLEFT",mainframe,"TOPLEFT",20,-270)
table_insert(Options,checkbox)

local checkbox=NPA_Options:CreateCheckBox("NPA_Options_Tracker_SelfName",mainframe,21,Localization["SelfName"],"Tracker_SelfName")
checkbox:SetPoint("TOPLEFT",mainframe,"TOPLEFT",145,-270)
table_insert(Options,checkbox)

local checkbox=NPA_Options:CreateCheckBox("NPA_Options_Tracker_SelfName",mainframe,21,Localization["SelfEnableMouse"],"Tracker_SelfEnableMouse")
checkbox:SetPoint("TOPLEFT",mainframe,"TOPLEFT",240,-270)
table_insert(Options,checkbox)


-----------------------------
local checkbox=NPA_Options:CreateCheckBox("NPA_Options_Tracker_Pet",mainframe,21,Localization["Pet"],"Tracker_Pet")
checkbox:SetPoint("TOPLEFT",mainframe,"TOPLEFT",20,-340)
table_insert(Options,checkbox)

local checkbox=NPA_Options:CreateCheckBox("NPA_Options_Tracker_PetName",mainframe,21,Localization["PetName"],"Tracker_PetName")
checkbox:SetPoint("TOPLEFT",mainframe,"TOPLEFT",145,-340)
table_insert(Options,checkbox)

local checkbox=NPA_Options:CreateCheckBox("NPA_Options_Tracker_PetName",mainframe,21,Localization["PetEnableMouse"],"Tracker_PetEnableMouse")
checkbox:SetPoint("TOPLEFT",mainframe,"TOPLEFT",240,-340)
table_insert(Options,checkbox)

---------------------------

local checkbox=NPA_Options:CreateCheckBox("NPA_Options_Tracker_Focus",mainframe,21,Localization["Focus"],"Tracker_Focus")
checkbox:SetPoint("TOPLEFT",mainframe,"TOPLEFT",20,-410)
table_insert(Options,checkbox)

local checkbox=NPA_Options:CreateCheckBox("NPA_Options_Tracker_FocusName",mainframe,21,Localization["FocusName"],"Tracker_FocusName")
checkbox:SetPoint("TOPLEFT",mainframe,"TOPLEFT",145,-410)
table_insert(Options,checkbox)

local checkbox=NPA_Options:CreateCheckBox("NPA_Options_Tracker_FocusName",mainframe,21,Localization["FocusEnableMouse"],"Tracker_FocusEnableMouse")
checkbox:SetPoint("TOPLEFT",mainframe,"TOPLEFT",240,-410)
table_insert(Options,checkbox)


------------------------------


local checkbox=NPA_Options:CreateCheckBox("NPA_Options_Tracker_Target",mainframe,21,Localization["Target"],"Tracker_Target")
checkbox:SetPoint("TOPLEFT",mainframe,"TOPLEFT",20,-480)
table_insert(Options,checkbox)

local checkbox=NPA_Options:CreateCheckBox("NPA_Options_Tracker_TargetName",mainframe,21,Localization["TargetName"],"Tracker_TargetName")
checkbox:SetPoint("TOPLEFT",mainframe,"TOPLEFT",145,-480)
table_insert(Options,checkbox)

local checkbox=NPA_Options:CreateCheckBox("NPA_Options_Tracker_TargetName",mainframe,21,Localization["TargetEnableMouse"],"Tracker_TargetEnableMouse")
checkbox:SetPoint("TOPLEFT",mainframe,"TOPLEFT",240,-480)
table_insert(Options,checkbox)


----------------------------
local listframe=NPA_Options:CreateFrame("NPA_Options_Tracker_Filter",mainframe)
listframe:SetPoint("TOPRIGHT",-6,-6)
listframe:SetWidth(240)

local checkboxdata={
	["Tracker_LeftWard"]=Localization["LeftWard"],
	["Tracker_UpWard"]=Localization["UpWard"],
}

NPA_Options:BuildCheckBoxList("NPA_Options_Tracker",listframe,20,checkboxdata,17,Options,1)


local listframe2=NPA_Options:CreateFrame("NPA_Options_Tracker_Filter",mainframe,Localization["Filter"])
listframe2:SetPoint("TOPRIGHT",listframe,"BOTTOMRIGHT",0,-20)
listframe2:SetPoint("TOPLEFT",listframe,"BOTTOMLEFT",0,-20)

local checkboxdata={
	["Tracker_Hostile"]=Localization["Hostile"],
	["Tracker_NonHostile"]=Localization["NonHostile"],
	["Tracker_Aura"]=Localization["HasAura"],
	["Tracker_Cast"]=Localization["Cast"],
	["Tracker_CastOnMe"]=Localization["IsCastOnMe"],
	["Tracker_CrowdControl"]=Localization["HasCrowdControl"],
	["Tracker_CounterSpell"]=Localization["HasCounterSpell"],
	["Tracker_CoolDown"]=Localization["HasCoolDown"],
	--["Tracker_RegisterGUID"]=Localization["RegisterGUID"]
}

NPA_Options:BuildCheckBoxList("NPA_Options_Tracker",listframe2,20,checkboxdata,17,Options,1)



local modulelist=NPA_Options:CreateCheckListEdit2("NPA_Options_Tracker_ModuleList",mainframe,Localization["ModuleList"],"Tracker_ModuleList",nil,nil,Localization)
modulelist:SetPoint("TOPRIGHT",mainframe,"TOPRIGHT",-3,-237)
modulelist:SetWidth(240)

local selfmodulelist=NPA_Options:CreateCheckListEdit2("NPA_Options_Tracker_SelfModuleList",mainframe,Localization["SelfModuleList"],"Tracker_SelfModuleList",nil,nil,Localization)
selfmodulelist:SetPoint("TOPRIGHT",mainframe,"TOPRIGHT",-3,-267)
selfmodulelist:SetWidth(240)

local petmodulelist=NPA_Options:CreateCheckListEdit2("NPA_Options_Tracker_PetModuleList",mainframe,Localization["PetModuleList"],"Tracker_PetModuleList",nil,nil,Localization)
petmodulelist:SetPoint("TOPRIGHT",mainframe,"TOPRIGHT",-3,-337)
petmodulelist:SetWidth(240)


local focusmodulelist=NPA_Options:CreateCheckListEdit2("NPA_Options_Tracker_FocusModuleList",mainframe,Localization["FocusModuleList"],"Tracker_FocusModuleList",nil,nil,Localization)
focusmodulelist:SetPoint("TOPRIGHT",mainframe,"TOPRIGHT",-3,-407)
focusmodulelist:SetWidth(240)


local targetmodulelist=NPA_Options:CreateCheckListEdit2("NPA_Options_Tracker_TargetModuleList",mainframe,Localization["TargetModuleList"],"Tracker_TargetModuleList",nil,nil,Localization)
targetmodulelist:SetPoint("TOPRIGHT",mainframe,"TOPRIGHT",-3,-477)
targetmodulelist:SetWidth(240)
end