﻿-- Author      : Nogarder
-- Create Date : 2012/3/8 1:35:48

if(NPA_Core:CheckHook("ClickZone"))then

local Localization={}
local Tooltips={}
local locale=GetLocale()
local table_insert = table.insert
local pairs = pairs

if(locale=="zhTW")then
	Localization={
		["PageName"]="點擊區",
		["Zone"]="區域材質",
		["Show"]="顯示區域材質",
		["Enable"]="啟用點擊區尺寸修改"
	}
	Tooltips={
		["ClickZone"]="修改和顯示姓名板的點擊范围; !!注意!!由於暴雪的限制,只有在脫離戰鬥時點擊區域的大小才可以變化,並且在隱藏後會重置"
	}
elseif(locale=="zhCN")then
	Localization={
		["PageName"]="点击区",
		["Zone"]="区域材质",
		["Show"]="显示区域材质",
		["Enable"]="启用点击区尺寸修改"
	}
	Tooltips={
		["ClickZone"]="修改和显示姓名板的点击范围; !!注意!!由于暴雪的限制,只有在脱离战斗时点击区域的大小才可以变化,并且在隐藏后会重置"
	}
else
	Localization={
		["PageName"]="ClickZone",
		["Zone"]="Zone Texture",
		["Show"]="Show zone-texture",
		["Enable"]="Enable forcing zone-size"

	}
	Tooltips={
		["ClickZone"]="Change and show click-range of Nameplates; !!Warning!! Due to Blizzard's limitation,the zone is only changable when out of combat, and will be reset after hiding"
	}
end


local mainframe=NPA_Options:AddPage("NPA_Options_ClickZone",Localization["PageName"],"ClickZone",Tooltips["ClickZone"])

local Options=mainframe.Options
---buttons

NPA_Options:CreateSliderEditButton(Localization["Zone"],mainframe,"ClickZone_Data",3,Options,0.5)


local listframe=NPA_Options:CreateFrame("NPA_Options_ClickZone_Filter",mainframe)
listframe:SetPoint("TOPRIGHT",-6,-6)
listframe:SetWidth(200)

local checkboxdata={
	["ClickZone_Show"]=Localization["Show"],
	["ClickZone_Enable"]=Localization["Enable"]
}

NPA_Options:BuildCheckBoxList("NPA_Options_ClickZone",listframe,21,checkboxdata,18,Options,1)
end