﻿-- Author      : Nogarder
-- Create Date : 2010/7/4 16:33:11

if(NPA_Core:CheckHook("QuestMark"))then

local Localization={}
local Tooltips={}
local locale=GetLocale()
local table_insert = table.insert
local pairs = pairs

if(locale=="zhTW")then
	Localization={
		["PageName"]="任務指示",
		["ShowFinished"]="顯示已完成的",
		["Text"]="文本",
		["ShowIcon"]="顯示圖標",
		["ShowText"]="顯示文本",
		["Icon"]="圖標",
	}
	Tooltips={
		["QuestMark"]="顯示任務相關單位的完成數量/總量"
	}
elseif(locale=="zhCN")then
	Localization={
		["PageName"]="任务指示",
		["ShowFinished"]="显示已完成的",
		["Text"]="文本",

		["ShowIcon"]="显示图标",
		["ShowText"]="显示文本",
		["Icon"]="图标",

	}
	Tooltips={
		["QuestMark"]="显示任务相关单位的完成数量/总量"
	}
else
	Localization={
		["PageName"]="QuestMark",
		["ShowFinished"]="Show finished",
		["Text"]="Text",

		["ShowIcon"]="Show icon",
		["ShowText"]="Show text",
		["Icon"]="Icon",

	}
	Tooltips={
		["QuestMark"]="Show counter/max number for quest unit"
	}
end


local mainframe=NPA_Options:AddPage("NPA_Options_QuestMark",Localization["PageName"],"QuestMark",Tooltips["QuestMark"])

local Options=mainframe.Options

NPA_Options:CreateSliderEditButton(Localization["Text"],mainframe,"QuestMark_TextData",2,Options,1)
NPA_Options:CreateSliderEditButton(Localization["Icon"],mainframe,"QuestMark_IconData",3,Options,2.5)



local checkbox=NPA_Options:CreateCheckBox("NPA_Options_QuestMark_ShowFinished",mainframe,21,Localization["ShowFinished"],"QuestMark_ShowFinished")
checkbox:SetPoint("TOPLEFT",mainframe,"TOPLEFT",20,-200)
table_insert(Options,checkbox)


local listframe=NPA_Options:CreateFrame("NPA_Options_QuestMark_Filter",mainframe)
listframe:SetPoint("TOPRIGHT",-6,-6)
listframe:SetWidth(200)

local checkboxdata={
	["QuestMark_ShowText"]=Localization["ShowText"],
	["QuestMark_ShowIcon"]=Localization["ShowIcon"],
	["QuestMark_ShowFinished"]=Localization["ShowFinished"],
}

NPA_Options:BuildCheckBoxList("NPA_Options_QuestMark",listframe,21,checkboxdata,18,Options,1)

end